Windmill Graphics Help Contents

Getting Started

Overview

Creating a background bitmap

Loading a background into Graphics

Configuring the hardware

Creating a new display - the New option

Inserting Dynamic Items

Inserting dynamic items

Inserting dynamic text

Inserting moving bars

Inserting changing icons

Creating a changing icon bitmap

Inserting analogue meters

Inserting analogue output buttons

Inserting digital output buttons

Inserting DDE output buttons

Editing or deleting dynamic items

Moving and resizing a dynamic item

Setting the speed of dynamic item update

Inserting DDE Controls - Send Commands and Data to Other Applications

Enabling DDE support

Inserting DDE output buttons

Summary of sending commands to other applications using DDE

Summary of sending data to other applications using DDE

Sending DDE execute commands to Graphics

Running the Graphics Display

Renaming the Graphics window

Running the display

Returning to Edit mode

Dropping a different background behind the dynamic items

Saving the Graphics Display

Saving a Graphics display

Opening a Graphics display

Specifying which Graphics modes are available

Resizing, moving and minimising

Altering the hardware setup file

Closing Graphics

Command Summary

Commands


Overview

The Graphics program lets you design and create your own display and control windows. These can be process mimic diagrams, wiring diagrams, bar charts, annunciator panels, virtual instruments or any other customised layout.

The Graphics display consists of a static background upon which you place real-time display and control items. The static background is a bitmap file which you create with the Windows Paint program, or any other painting package that handles bitmap files.

There are 7 types of Dynamic items: Dynamic Text, Moving Bars, Changing Icons, Analogue Meters, Analogue Control Buttons, Digital Control Buttons and DDE Control Buttons.

Graphics has two modes, Edit and Run. You create the displays in Edit mode and set them to work in Run mode. You can load Graphics in either Edit or Run mode and can disable Edit mode if necessary.

You can run several copies of Graphics at the same time, so showing more than one display at once.

To use Graphics:

  1. Create a background
  2. Load the background into Graphics
  3. Configure the hardware
  4. Add dynamic items


Creating a Background Bitmap

The background is the static part of the display that lies under the dynamic items. The background image can be in either bitmap (.bmp) or run length encoded (.rle) format. Use a painting package like Windows Paint to create the background.

Here are some tips on how to creating a bitmap background for Graphics.

  1. Set the size of your bitmap:Graphics always displays the background the same size as it was created. Do not enter bitmap sizes that exceed the resolution of your screen; Graphics will not scroll images. Also remember that Graphics will need additional room for a title bar.
  2. You may find it useful to note down the co-ordinates off the background bitmap where you later intend to add dynamic items.
  3. In areas where you intend to add dynamically changing icons, draw the icon in the off state: for example a closed valve. You can then copy this area and save it in its own bitmap file, so ensuring that the icon is the correct size and colour.
  4. Save the picture in the Windmill directory.

When you have created a background you are ready to use Graphics. You can always switch back to the painting package if you need to edit the background, or create a new one.


Loading a Background into Graphics

  1. Select Background image from the Settings menu.
  2. Select a background and the Graphics window is automatically resized to accommodate and display the image. (You should have already created the background using a painting package.)


Configuring the Hardware

You configure the data acquisition hardware by sending it a hardware setup file (an .ims file). This is created by the SetupIML program. To load a setup select Hardware Setup file from the Settings menu.

You can either load a setup from disk or select one that is already in use by another Windmill application. If the applications are using the same channels, you must specify the same setup file for each.

Take care when loading new setups after you have added dynamic items. If the new setup disables or does not contain the channel assigned to the dynamic item, the item will not function correctly.


Creating a New Display - The New Option

Choose New from the File menu to clear the display and setup details in preparation for starting again. It also allows you to be guided through the main sequence of steps needed to create a display. If you continue, you will automatically be given the options to:

  1. Load a copy of Paint allowing a new background to be created or edited.
  2. Load a background bitmap.
  3. Load a copy of SetupIML, letting you create or edit a hardware setup file.
  4. Load a hardware setup file.

Once the sequence has finished you are ready to add dynamic items to the display.

If you answer Yes to the Paint option of the New sequence then as soon as Paintbrush is loaded, Graphics will ask if you want to load a background. You should ignore this message for the time being and switch back to Paintbrush, where you can create a background bitmap. After saving the bitmap you can return to Graphics and continue with the New sequence.

Press Cancel in any of the New message boxes to stop the New sequence.


Inserting Dynamic Items

Once you have selected the background and configured the hardware you can insert the dynamic items. Most items represent or control one channel of data. The DDE output button, however, lets you send commands and data to other Windows programs.

To insert a dynamic item either double-click the background in Graphics, or use the mouse to select an area. This will generally be the item's default size. Changing icons, however, will be kept at their original size.

To select an area press and hold down the left mouse button, drag the cursor until the box encloses the desired area and release the mouse button.

The cursor report window will help you position the mouse. This window initially appears over the title bar but you can move it if you wish. The x and y co-ordinates of the cursor are shown in pixels.

When you select an area the Create new dynamic item dialogue box appears. Select the type of item you wish to insert and a Dynamic Item Settings dialogue box appears, according to the item selected.


Inserting Dynamic Text

A Dynamic Text item comprises either the channel name or reading, or the current time or date, on a rectangular background. To insert Dynamic Text either double-click the Graphics background or use the mouse to select an area corresponding to the size and position of the text background.

Channel Name

Assign either an analogue or digital input channel to dynamic text, or the current time or date. Make your choice from the list.

X and Y Positions

Use the X and Y Position boxes to set the exact position of the top left-hand corner of the text background. Initially these show, in pixel units, the co-ordinates of the top left hand corner of the area you selected with the mouse.

Width and Height

The text is positioned on a rectangular background. Use the Width and Height boxes to specify the size of the background in pixel units.

Maximum Characters

This restricts the number of characters that are displayed, so you can reduce the number of digits shown. For example if you choose to display a maximum of 5 characters, a thermocouple channel reading of 23.1256 will be shown as 23.12.

Graphics displays the first "n" characters regardless of where the decimal point is, so be careful that you don't shorten the value so much that a wrong reading is shown. For instance if you chose 4 characters then 92662.84 would be shortened to 9266.

The Maximum Characters value must be between 1 and 15, inclusive.

Display Name or Value

You can display either the name of the channel or the current value of the channel. Just click on the relevant button. If you chose to display the current Time or Date, this will be shown regardless of the Name or Value selection.

Alignment of Text

Text can be left aligned, right aligned or centred relative to its background.

Colour of Text

You can set both the text background colour and the colour of the text itself. If you have specified alarms for the channel you can choose different colours for different alarm states. (Alarms are specified in SetupIML.)

Font of Text

Press the Font button to change the font of the text. A dialogue box appears which lets you select the typeface, type style and type size.

Deleting the Text

Press the Delete button to remove the dynamic text item from the main background.


Inserting Moving Bars

Moving bars example
Moving bars example

Each moving bar item consists of a bar, a background to the bar and a frame outlining the background. To insert a moving bar either double-click the background or use the mouse to select an area corresponding to the size and position of the moving bar background.

Channel Name

Assign an analogue input channel to a moving bar. Select a channel from the list of those available in the current hardware setup.

X and Y Positions

Use the X and Y Position boxes to set the exact position of the top left-hand corner of the frame. Initially these show, in pixel units, the co-ordinates of the top left hand corner of the area you selected with the mouse.

Bar Type

Select a vertical or horizontal bar from the Bar Type box.

Bar Length and Width

Use the Length and Width boxes to specify the size of the bar item in pixels. (The frame is always 1 pixel wide.)

Values at Top and Bottom or Left and Right of Bar

You should specify the maximum and minimum data values that you want to be displayed. These are represented by the top and bottom of a vertical bar, or right and left of a horizontal bar. Select Default to select the extremes of the channel's range (set in SetupIML).

Colours

You can set the colour of the bar, its background colour and the colour of the frame. The bar can have different colours depending on its alarm state. Just choose a colour for each from the list.

Deleting the Moving Bar

Press the Delete button to remove the bar item from the main background.


Inserting Changing Icons

changing icons
Changing icon example

Changing icons are bitmap files which you should have created and saved in the same directory as the backgrounds.

To insert a changing icon either double-click the background or use the mouse to select an area corresponding to the size and position of the moving bar background.

Channel Name

Assign either a digital channel or an alarm channel to changing icons (i.e. a channel that has two states). Select a channel from the list of those available in the current hardware setup.

X and Y Positions

Use the X and Y Position boxes to set the exact position of the top left-hand corner of the icon. Initially these show, in pixel units, the co-ordinates of the top left hand corner of the area you selected with the mouse.

Bitmap when 0 or 1

Choose one bitmap file to represent the 0 state (line low or no alarm) and one to represent the 1 state (line high or in alarm).

Deleting the Icon

Press the Delete button to remove the icon from the background.


Creating a Changing Icon Bitmap

The changing icon dynamic item requires two bitmaps of identical size; one representing the off state of the channel and one representing the on state. Use Paint (or other painting package) to create and edit these images. If you have drawn either state on the background bitmap , you can copy the icon and save it in its own bitmap file.

  1. In Paint open the background bitmap and select the area containing the icon, noting the top left corner position.
  2. Select Copy To from the Edit menu to save the selected area in its own file. Use a filename that identifies the bitmap image, for example Valve_0.bmp, and save it in the Windmill directory.
  3. Open the new file. Notice that the image attributes are correctly set to the bitmap's size.
  4. Use Paint to edit the bitmap to represent the other state and save the image in a third bitmap file, again using a suitable filename to identify the image, for example Valve_1.bmp.

You should now have two suitable bitmap files to represent the channel.

Related topics:

Inserting changing icons


Inserting Analogue Meters

annotated analogue meter
An analogue meter

An Analogue Meter consists of a rectangular background, a circular scale with different coloured zones to show alarms, and labels.

To insert an analogue meter either double-click the background or use the mouse to select an area corresponding to the size and position of the meter background.

Channel Name

Assign an analogue input channel to an analogue meter. Select a channel from the list of those available in the current hardware setup.

Meter Label

You can choose a name for the meter by typing up to 15 characters into the Meter Label box. You do not have to label the meter and can leave this box blank if you wish. Labels are not shown if you give the meter a transparent background.

X and Y Positions

Use the X and Y Position boxes to set the exact position of the top left-hand corner of the meter background. Initially these show, in pixel units, the co-ordinates of the top left hand corner of the area you selected with the mouse.

Height and Width

Use the Height and Width boxes to specify the size of the Analogue Meter background in pixel units.

Meter Type

There are several types of meter available, allowing different angles and orientations of the scale. Select one from the list.

Display Scale

If you wish you can turn off the scale. Click the check box to remove the cross or tick.

Label Minimum and Maximum Values

You can choose whether to display the range of the meter or not. Check the Label min/max values box and the range will be shown. (Set the meter range in the Lower and Upper Range Value boxes.)

Transparent Background

You can set the meter background to be transparent, so the underlying main background can be seen. Click the check box so it's marked with a cross or tick.

Number of Ticks

You can set the number of ticks on the scale - type a number into the Number of Ticks box. If you do not want any ticks enter 0 or leave the box blank.

Lower and Upper Range Values

You must specify the lower and upper values of the meter's range. Select Default to select the extremes of the input channel's range (set in SetupIML).

Colours

You can set: the colour of the scale when the channel is in normal, warning alarm or critical alarm states, the colour of the meter background, and the colour of the text or labels.

Deleting the Analogue Meter

Press the Delete button to remove the analogue meter from the main background.


Inserting Analogue Output Buttons

An Analogue Output item appears on the main background as a labelled control button. Pressing the button leads to a small dialogue box in which the operator enters the value to be output. To insert an analogue output button either double-click the background or use the mouse to select an area corresponding to the size and position of the button.

Output Channel Name

Assign an analogue output channel to an analogue button. Select a channel from the list of those available in the current hardware setup.

X and Y Positions

Use the X and Y Position boxes to set the exact position of the top left-hand corner of the button. Initially these show, in pixel units, the co-ordinates of the top left hand corner of the area you selected with the mouse.

Button Height and Width

Use the Height and Width boxes to specify the size of the button in pixel units.

Button Label

Type a label for the button. The text will be centred.

Function Key

You can assign a Function key to the button, letting the operator select the button without using the mouse. You may find it helpful to display the Function key action either on the button or on the background; making it clear to the operator what will happen when they press the key.

Make Button Transparent

You can make the button transparent by checking the Transparent box. This means you can place the control over an appropriate part of the background and instead of a standard button you can have any design of output item you wish.

Minimum and Maximum Output Values

You should specify the minimum and maximum values that you will allow to be output. Press Default to select the extremes of the channel's range (set in SetupIML).

Initial Value of Output

Enter the value you want to the channel to output when Graphics starts running. This value will only be output if the Initialise Channel Output box is checked.

Initialise Channel Output

If you want Graphics to output a value as soon as it starts running, check the Initialise Channel Output box.

Deleting the Button

Press the Delete button to remove the Analogue Output item from the main background.


Inserting Digital Output Buttons

A Digital Output item appears on the main background as a labelled control button. To insert a Digital output button either double-click the background or use the mouse to select an area corresponding to the size and position of the button.

Output Channel Name

Assign a digital output channel to a digital button. Select a channel from the list of those available in the current hardware setup.

X and Y Positions

Use the X and Y Position boxes to set the exact position of the top left-hand corner of the button. Initially these show, in pixel units, the co-ordinates of the top left hand corner of the area you selected with the mouse.

Button Height and Width

Use the Height and Width boxes to specify the size of the button in pixel units.

Button Label

Type a label for the button. The text will be centred.

Function Key

You can assign a Function key to the button, letting the operator to select the button without using the mouse. You may find it helpful to display the Function key action either on the button or on the background; making it clear to the operator what will happen when they press the key.

Make Button Transparent

You can make the button transparent by checking the Transparent box. This means you can place the control over an appropriate part of the background and instead of a standard button you can have any design of output item you want.

Button Type

There are 3 types of Digital button: a button that toggles between on and off, a button that always turns an output on and a button that always turns an output off. Choose one from the list.

Include Button On Indicator

If you chose a Toggle button as the button type, you can also choose to automatically show when the output is on, (line high). Check the Include Button On Indicator box. This adds an "LED" to the button which "lights up" when the output is on.

Initialise Channel Output

If you want Graphics to output a value as soon as it starts running, check the Initialise Channel Output box.

Initial Output State

Choose the value you want to the channel to output when Graphics starts Running. This can be either 1 (line high or on) or 0 (line low or off).

Deleting the Button

Press the Delete button to remove the Digital Output item from the main background.


Inserting DDE Output Buttons

DDE output buttons let you send commands and data to other Windows programs that support dynamic data exchange. You can tell Excel to run a macro for instance. To insert a DDE button either double-click the background or use the mouse to select an area corresponding to the size and position of the button.

Button Controls

Button Label
X and Y Positions
Height and Width
Making the Button Transparent
Deleting the Button

DDE Commands

Command Type
Service Name
Topic Name
Item Name
Data
Execute Command
Requesting data from the operator when DDE button is pressed
Prompting the Operator


Editing or Deleting a Dynamic Item

Double-click over a dynamic item to recall its Settings dialogue box. Change any settings you wish and press OK to replace the item.

To delete the item double-click to bring up its dialogue box then press Delete.

When the cursor is over a dynamic item it changes shape and a small windo shows the co-ordinates of the edge of the item.

You can only edit items when in Edit, not Run, mode.


Moving and Resizing a Dynamic Item

You can move a dynamic item either by clicking and dragging with the mouse, or by altering its co-ordinates in the Settings dialogue box. You can only resize the item in the dialogue box. (To open the Settings box double-click the dynamic item.)


Setting the speed of dynamic item updates

Setting the Speed of Dynamic Item Update

You can change the update rate (initially every second) by selecting Update from the Settings menu.

Erase 1.0 and type the new update rate in seconds. You can choose any value between 0.1 and 3600, in increments of 1 decimal place. This is the target interval that Graphics will attempt to achieve. The fastest rates may not be possible if several applications are running or several dynamic items are displayed.


Enabling DDE Support

Graphics can send commands, or data, to other applications by means of dynamic data exchange. It can also receive commands from other applications. In the first case it is acting as a Client, or Destination and the second as a Server, or Source. A Server responds to instructions from a Client.

Windows programs cannot make DDE conversations unless they have a unique DDE Service Name. The first instance of Graphics loaded will be given the service name "Graphics". To change this, or allocate a service name to another instance of the program, select DDE from the File menu. A dialogue box appears for you to enter a new Service Name.

Graphics supports CF text format which most DDE applications use.


Summary of Sending Commands to Other Applications using DDE

Fill in the DDE Output button dialogue box as follows.

  1. Select Execute Command as the command type.
  2. Select the Service name of the application to which you want to send commands.
  3. If you're sending commands to non-Windmill applications enter a Topic name. This is often the name of a file. See the Manual of your chosen Server application for details.
  4. Enter the command you want to send. See the Manual of your chosen Server application for details of the commands it supports.


Summary of Sending Data to Other Applications using DDE

Fill in the DDE Output button dialogue box as follows.

  1. Select Poke Data as the command type.
  2. Select the Service name of the application to which you want to send data.
  3. Enter a Topic name. This is often the name of the file to which you want to send data. For Windmill programs enter DATA.
  4. Use the Item name to specify the desired location of the data. In a spreadsheet, for instance, the Item name would be the address of a cell, or range of cells.
  5. Enter the data values to be sent, or choose to defer entry until the DDE button is pressed.


DDE execute commands

Sending DDE Execute Commands to Graphics

Graphics can accept these DDE Execute commands: Destroy, Interval, Load, Maximize, Minimize, Move, Print, Restore, Start and Stop.

Commands are shown in upper case and their parameters in angled brackets. Parameters should be separated by a single space.

Execute Commands Accepted By Graphics

DESTROY
Closes Graphics. Equivalent of the Exit command on the File menu.
INTERVAL <new interval>
Determines how often the other application reads Graphics's channels. The interval parameter specifies the interval in seconds. For example a 500 millisecond update rate would be specified as:
Interval 0.5
LOAD <setup file name>
Loads a new setup file. If the setup file is not in the current directory you should specify the complete file path. You could use this command to change the current view.
MAXIMIZE
Makes the Graphics window full screen size.
MINIMIZE
Iconises Graphics. Equivalent of the Minimize command on the System menu.
MOVE <x pos> <y pos>
Moves Graphics. The co-ordinates are in pixel units and refer to the position of the top left hand corner of the window. They are absolute, not relative to the current position.
For example: Move 5 5
PRINT
Prints the Graphics display to the default Windows printer, specified in Windows Control Panel.
RESTORE
Restores Graphics to the size it was before it was minimised. Equivalent of the Restore command on the System menu.
START
Starts Graphics running.
STOP
Stops Graphics running.


Renaming the Graphics windows

Renaming the Graphics Window

The title bar of the Graphics window initially reads "Windmill Graphics Display". You can change this by selecting Title from the Settings menu.

Type your own title. This is shown when Graphics is in Run mode.


Running the Display

Select Run from the menu bar and the display you have created is set to work. Graphics goes into Run mode and the display is regularly updated with real-time data. The menu bar disappears leaving just the System menu.

When you move the cursor over a dynamic item it changes shape, especially useful with transparent items.

You can set Graphics to load in Run mode, and disable the Edit mode, so no one can make any changes to the display.


Returning to Edit Mode

Select Edit Mode from the System menu to return to Edit mode from Run mode. (Click the icon on the left of the title bar.) You cannot return to Edit mode if you specified /R as a command line argument.


Dropping a Different Background Behind the Dynamic Items

Select Background Image from the Settings menu. The Open dialogue box appears. Select a background and it is dropped behind the dynamic items, replacing the original background file.


Saving a Graphics Display

  1. Select Save from the File menu.
  2. Type a name for the Graphics display into the Filename box. You don't need to specify an extension as .wgr is automatically added.
  3. Press OK.

The saved .wgr file contains these details:

  • Name of the Background file
  • Dynamic item settings
  • Name of the Hardware setup file
  • Title of the Graphics window
  • Update rate
  • DDE enabled and service name


Opening a Graphics Display

  1. Select Open from the File menu to call up the Open dialogue box with a list of *.wgr files.
  2. Select a file and press OK to load the display and hardware setup file.


Specifying Which Graphics Modes are Available

You can choose which Graphics modes are available and how Graphics will appear when first started, by specifying a command line argument in Windows.

You have 3 choices:

  • Start Graphics in Edit mode with a specified display.
  • Start Graphics in Run mode with a specified display, with the option to switch to Edit mode.
  • Start Graphics in Run mode with a specified display, with Edit mode disabled.

Start-Up Option

Command Line Argument

Edit mode + specified display | graphics mimic.wgr
Run mode + specified display + enabled Edit mode | graphics mimic.wgr /A
Run mode + specified display + disabled Edit mode | graphics mimic.wgr /R

Specifying a Command Line Argument

Right click the Graphics icon on the desk top. Select Properties and choose the Shortcut tab. Type into the Target box.

Now when you load Graphics it will start in your chosen mode with your chosen display.


Resizing, Moving and Minimising

The size of the Graphics window depends upon the size of the background. You cannot change the size of the window but you can move or iconise it in the same way as other Windows applications.


Altering the Hardware Setup File

You can alter the hardware setup file (*.ims) with SetupIML. You can move to SetupIML and change some of the details in the current setup file, for instance the range or units, without closing Graphics - provided that you are in Edit not Run mode. When you next return to Run mode the affected parameters are automatically updated. You can also access SetupIML from the New sequence.


Closing Graphics

You can close the Graphics windows either by selecting Close from the System menu (Edit and Run modes) or by selecting Exit from the File menu (Edit mode only).


File Menu

New

Clears the display and setup details in preparation for starting again. Also gives you the option of being guided through the main sequence of steps needed to create a display.

Related topics:

Creating a new display: the New option

Open

Opens a Graphics display.

Related topics:

Opening a Graphics display

Save

Saves a Graphics display.

Related topics:

Saving a display

Save As

Saves a Graphics display under a new name.

Related topics:

Saving a display

DDE

Enables DDE support.

Related topics:

Enabling DDE support

Exit

Closes Graphics.

Related topics:

Closing Graphics


Settings Menu

Background Image

Loads a new background behind any dynamic items.

Related topics:

Dropping a different background behind the dynamic items

Hardware Setup file

Configures the hardware by sending it a setup file of your choice (an *.ims file).

Related topics:

Configuring the hardware

Title

Changes the title of the Graphics window.

Related topics:

Renaming the Graphics window

Update

Changes the speed of update of dynamic items.

Related topics:

Setting the speed of dynamic item update


Run

Run Menu

Runs the Graphics window so it shows real-time updates.

Related topics:

Running the display


World Wide Web

Web Site

You can find more information about Windmill Software on the World Wide Web at http://www.windmill.co.uk/.

Every month we publish a free newsletter - Monitor ((ISSN 1472-0221), delivered by e-mail. This gives tips on using Windmill and articles on data acquisition and control. To subscribe visit http://www.windmill.co.uk/newsletter.html.

For easy purchase of extra software modules visit http://www.windmillsoft.com/.

Updates of this Help file will be posted at http://www.windmill.co.uk/help.html.


Windmill

Windmill is a suite of data acquisition and control software. It comprises:

Drivers - which handle the low-level communications

ConfIML - which creates a file holding details on which hardware devices are in your system

SetupIML - which creates files telling the other applications how you want the hardware configured

Applications - such as Logger and Chart which perform the data acquisition and control tasks


Windmill

Contacting Windmill

Windmill Software,
PO Box 58,
North District Office,
Manchester,
M8 8QR,
UK
Telephone: +44 (0)161 833 2782
Facsimile: +44 (0)161 833 2190
E-mail: sales@windmill.co.uk
http://www.windmillsoft.com/
http://www.windmill.co.uk/


Your Comments on the Help

Tell us any improvements we could make to our Help files. Could you quickly find what you wanted? Was the explanation clear? Have you any questions? Visit http://www.windmill.co.uk/help.html and fill in the comments form at the bottom of the page.


Streamer

Streamer is waveform capture, charting and review software for Windows. It lets you log data (temperature, strain, current, etc) at up to 100 kHz. You can set the speed of sampling from Streamer or from an external clock, and start scans from Streamer or from an external trigger.

Streamer works with Microlink high speed data acquisition hardware.

For more information on Streamer, or to download a free software demo, visit Windmill Software's web site at http://www.windmill.co.uk/.


Analogue Meter Settings

annotated analogue meter
An analogue meter

An Analogue Meter consists of a rectangular background, a circular scale with different coloured zones to show alarms, and labels.

Channel Name

Assign an analogue input channel to an analogue meter. Select a channel from the list of those available in the current hardware setup.

Meter Label

You can choose a name for the meter by typing up to 15 characters into the Meter Label box. You don't have to label the meter and can leave this box blank if you wish. Labels are not shown if you give the meter a transparent background.

X and Y Positions

Use the X and Y Position boxes to set the exact position of the top left-hand corner of the meter background. Initially these show, in pixel units, the co-ordinates of the top left hand corner of the area you selected with the mouse.

Height and Width

Use the Height and Width boxes to specify the size of the Analogue Meter background in pixel units.

Meter Type

There are several types of meter available, allowing different angles and orientations of the scale. Just select one from the list.

Display Scale

If you wish you can turn off the scale. Click on the check box to remove the cross.

Label Minimum and Maximum Values

You can choose whether to display the range of the meter or not. Check the Label min/max values box and the range will be shown. (The meter range is set in the Lower and Upper Range Value boxes.)

Transparent Background

You can set the meter background to be transparent, so the underlying main background can be seen. Click the check box so it's marked with a cross or a tick.

Number of Ticks

You can set the number of ticks on the scale - type a number into the Number of Ticks box. If you don't want any ticks enter 0 or leave the box blank.

Lower and Upper Range Values

You must specify the lower and upper values of the meter's range.

Default Button

Press the Default button to set the minimum or maximum output value to be the same as the extent of the channel's range (set in SetupIML).

Colours

You can set the colour of the scale when the channel is in normal, warning alarm or critical alarm states; the colour of the meter background and the colour of the text or labels.

Delete Button

Press the Delete button to remove the analogue meter from the main background.


Moving Bar Settings

Moving bars example
Moving bars example

Each moving bar item consists of a bar, a background to the bar and a frame outlining the background.

Channel Name

Assign an analogue input channel to a moving bar. Select a channel from the list of those available in the current hardware setup.

X and Y Positions

Use the X and Y Position boxes to set the exact position of the top left-hand corner of the frame. Initially these show, in pixel units, the co-ordinates of the top left hand corner of the area you selected with the mouse.

Bar Type

Select a vertical or horizontal bar from the Bar Type box.

Length and Width

Use the Length and Width boxes to specify the size of the bar in pixels. (The frame is always 1 pixel wide.)

Values at Top and Bottom or Left and Right of Bar

You must specify the maximum and minimum data values that you want to be displayed. These are represented by the top and bottom of a vertical bar or right and left of a horizontal bar.

Default Button

Press the Default button to set the minimum or maximum data value to be the same as the extent of the channel's range (set in SetupIML).

Colours

You can set the colour of the bar, its background colour and the colour of the frame. The bar can have different colours depending on its alarm state. Just choose a colour for each from the list.

Delete Button

Press the Delete button to remove the moving bar from the main background.


DDE Output Button Settings

DDE output buttons let you send commands and data to other Windows programs that support dynamic data exchange.

Button Label

You can type a label for the button. The text will be centred.

Function Key

You can assign a Function key to the button, so the operator can select the button without using the mouse. You may find it helpful to display the Function key action either on the button or on the background; making it clear to the operator what will happen when they press the key.

Transparent

You can make the button transparent by checking the Transparent box. This means you can place the control over an appropriate part of the background and instead of a standard button you can have any design of output item you want.

X and Y Positions

Use the X and Y Position boxes to set the exact position of the top left-hand corner of the button. Initially these show, in pixel units, the co-ordinates of the top left hand corner of the area you selected with the mouse.

Height and Width

Use the Height and Width boxes to specify the size of the button in pixel units.

Command Type

You can choose between an Execute command and a Poke command. Just make your selection from the list.

Use Poke when you want to send data values to another application. Use Execute when you want to send commands, for example to run a macro from Excel.

Service Name

The Service Name identifies the program you want to communicate with. Those currently available are listed, but you can ignore these and type in your own choice. You should enter a Service Name for both Poke and Execute commands.

Topic Name

The Topic Name is the subject of the DDE conversation. It is often the name of a file. You should read the Manual of your chosen Server application for details of the Topics it supports. You don't need a topic name if sending commands to other Windmill programs.

Item Name

The Item Name identifies where to send data to. For example, in Windmill programs the Item would be the name of a channel; in a spreadsheet the Item would be the address of a cell, or range of cells.

As the Item Name is concerned with sending and receiving data values, you only need use it with Poke commands. It will be disabled if you have selected an Execute command type.

Data

If you know the data value you want to send with a Poke command, type this in the Data box. Alternatively you can defer entry until the operator presses the DDE Output button. The Data box is disabled if you have selected an Execute command.

Execute Command

The Execute Commands available to Windmill programs currently running are listed, although these standard items may require parameters. For non-Windmill programs you can type your own Execute command. See your targeted application's manual for details of the commands it supports.

Request data from operator when button pressed

Check this box if you want the data sent in Poke commands to be entered when the DDE button is pressed. When this box is checked you can also specify a message to prompt the operator for the data.

Operator Prompt

Type a message to prompt the operator to enter the Poke data values.

Delete Button

Press the Delete button to remove the DDE button from the background.

Note that for DDE conversations to be successful you must use the DDE option on the Settings menu to enable DDE support. Also, you must have started the application with which you are trying to communicate.


Shell DDE Service Name

Ignore the Shell Service name which may be listed in the Graphics Service name options. This identifies facilities of Program Manager which are used by system developers. Graphics cannot use these, but recognises that they are there.


Digital output settings

Digital Output Button Settings

A Digital Output item appears on the main background as a labelled control button.

Output Channel Name

Assign a digital output channel to a digital button. Select a channel from the list of those available in the current hardware setup.

X and Y Positions

Use the X and Y Position boxes to set the exact position of the top left-hand corner of the button. Initially these show, in pixel units, the co-ordinates of the top left hand corner of the area you selected with the mouse.

Button Height and Width

Use the Height and Width boxes to specify the size of the button in pixel units.

Button Label

You can type a label for the button. The text will be centred.

Function Key

You can assign a Function key to the button, so the operator can select the button without using the mouse. You may find it helpful to display the Function key action either on the button or on the background; making it clear to the operator what will happen when they press the key.

Transparent

You can make the button transparent by checking the Transparent box. This means you can place the control over an appropriate part of the background and instead of a standard button you can have any design of output item you want.

Button Type

There are 3 types of Digital button: a button which toggles between on and off, a button which always turns an output on and a button which always turns an output off. Choose one from the list.

Include Button On Indicator

If you chose a Toggle button as the button type, you can also choose to automatically show when the output is on, (line high). Check the Include Button On Indicator box. This adds an "LED" to the button which "lights up" when the output is on.

Initialise Channel Output

If you want Graphics to output a value as soon as it starts running, check the Initialise Channel Output box.

Initial Output State

Choose the value you want to the channel to output when Graphics starts Running. This can be either 1 (line high or on) or 0 (line low or off).

Delete Button

Press the Delete button to remove the Digital Output button from the background.


Changing Icons Settings

changing icons
Changing icon example

Changing icons are bitmap files which you create in your painting package.

Channel Name

Assign either a digital channel or an alarm channel to changing icons (i.e. a channel that has two states). Select a channel from the list of those available in the current hardware setup.

X and Y Positions

Use the X and Y Position boxes to set the exact position of the top left-hand corner of the frame. Initially these show, in pixel units, the co-ordinates of the top left hand corner of the area you selected with the mouse.

Bitmap when 0 or 1

Choose one bitmap file to represent the 0 state (line low or no alarm) and one to represent the 1 state (line high or in alarm).

Delete Button

Press the Delete button to remove the icon from the background.


DDE Commands

Command Type

You can choose between an Execute command and a Poke command. Make your selection from the list.

Use Poke when you want to send data values to another application. Use Execute when you want to send commands.

You can also send Execute commands to Graphics itself. For example to load a new setup into Graphics, perhaps showing a different part of the process being monitored.

Service Name

The Service Name identifies the program you want to communicate with. Those currently available are listed, but you can ignore these and type your own choice. Enter a Service Name for both Poke and Execute commands.

Topic Name

The Topic Name is the subject of the DDE conversation. It is often a file name. You should read the Manual of your chosen Server application for details of the Topics it supports.

Item Name

The Item Name identifies where you want to send data to. For example, in Windmill programs the Item would be the name of a channel; in a spreadsheet the Item would be the address of a cell, or range of cells.

As the Item Name is used to send and receive data values, you only need it with Poke commands. It will be disabled if you have selected an Execute command type.

Data

The data values you want to send with a Poke command can be entered in the Data box. Alternatively you can defer entry until the DDE button is pressed. The Data box will be disabled if you have selected an Execute command.

Execute Command

The Execute Commands currently available to Windmill programs are listed, although these standard items may require parameters. For non-Windmill programs type your own Execute command.

Requesting data from the operator when DDE button is pressed

Check this box if you want the data sent in Poke commands to be entered when the DDE button is pressed. When this box is checked you can also specify a message to prompt the operator for the data.

Prompting the Operator

Type a message which will prompt the operator to enter the Poke data values.


Dynamic Text Settings

A dynamic text item consists of the channel name or reading on a rectangular background.

Channel Name

Assign either an analogue or digital input channel to dynamic text, or the current time or date. Select your choice from the list.

X and Y Positions

Use the X and Y Position boxes to set the exact position of the top left-hand corner of the text background. Initially these show, in pixel units, the co-ordinates of the top left hand corner of the area you selected with the mouse.

Width and Height

The text is positioned on a rectangular background. Use the Width and Height boxes to specify the size of the background in pixel units.

Maximum Characters

This restricts the number of characters that are displayed, so you can reduce the number of digits being shown. For example if you choose to display a maximum of 5 characters, a thermocouple channel reading of 23.1256 will be shown as 23.12.

Graphics displays the first "n" characters regardless of where the decimal point is, so be careful that you don't shorten the value so much that a wrong reading is shown. For instance if you chose 4 characters then 92662.84 would be shortened to 9266.

The Maximum Characters value must be between 1 and 15, inclusive.

Display Channel Name or Value

You can display either the name of the channel or the current value of the channel. Just click on the relevant button. If you chose to display the current Time or Date, this will be shown regardless of your Name or Value selection.

Alignment

Text can be left aligned, right aligned or centred relative to its background.

Text Colour

You can set both the text background colour and the colour of the text itself. If you have specified alarms for the channel you can choose different colours for different alarm states. (Alarms are specified in SetupIML.)

Font Button

Press the Font button to change the font of the text. A dialogue box appears which lets you select the typeface, type style and type size.

Delete Button

Press the Delete button to remove the dynamic text item from the main background.


Analogue Output Settings

Analogue Output Button Settings

An Analogue Output item appears on the main background as a labelled control button. Pressing the button leads to a small dialogue box in which the operator enters the value to be output.

Output Channel Name

Assign an analogue output channel to an analogue button. Select a channel from the list of those available in the current hardware setup.

X and Y Positions

Use the X and Y Position boxes to set the exact position of the top left-hand corner of the button. Initially these show, in pixel units, the co-ordinates of the top left hand corner of the area you selected with the mouse.

Button Height and Width

Use the Height and Width boxes to specify the size of the button in pixel units.

Button Label

You can type a label for the button. The text will be centred.

Function Key

You can assign a Function key to the button, so the operator can select the button without using the mouse. You may find it helpful to display the Function key action either on the button or on the background; making it clear to the operator what will happen when they press the key.

Transparent

You can make the button transparent by checking the Transparent box. This means you can place the control over an appropriate part of the background and instead of a standard button you can have any design of output item you want.

Minimum and Maximum Output Values

You must specify the minimum and maximum values that you will allow to be output.

Default Button

Press the Default button to set the minimum or maximum output value to be the same as the extent of the channel's range (set in SetupIML).

Initial Value of Output

Enter the value you want to the channel to output when Graphics starts Running. This value will only be output if the Initialise Channel Output box is checked.

Initialise Channel Output

If you want Graphics to output a value as soon as it starts running, check the Initialise Channel Output box.

Delete Button

Press the Delete button to remove the Analogue Output button from the background.


Commands

File

New
Open
Save
Save As
Exit

Settings

Background Image
Hardware Setup file
Title
Update

DDE

Run


(Untitled)

Windmill Graphics Help
designed and written
by Jill Studholme
http://www.studholme.net/


Create New Dynamic Item

Most dynamic items represent or control one channel of data. The DDE output button, however, lets you send commands and data to other Windows programs. Changing icons are bitmap files which you should have created and saved in your painting package, in the same directory as the backgrounds.

Select the type of item you wish to insert and press OK. You can now assign a channel to the item, set its colours, change its position, and so on.


DDE Button Controls

Button Label

Type a label for the button. The text will be centred.

X and Y Positions

Use the X and Y Position boxes to set the exact position of the top left-hand corner of the button. Initially these show, in pixel units, the co-ordinates of the top left hand corner of the area you selected with the mouse.

Height and Width

Use the Height and Width boxes to specify the size of the button in pixel units.

Making the Button Transparent

You can make the button transparent by checking the Transparent box. This means you can place the control over an appropriate part of the background and instead of a standard button you can have any design of output item you want.

Deleting the Button

Press the Delete button to remove the DDE item from the main background.